{Alternativni reseni k uloze o mafii}
{$S-}
program mafie;
const
  MAXN = 100100;
type
  LongArray = Array[1..MAXN] of LongInt;
var
  n, p : LongInt;
  deg : Array[1..MAXN] of LongInt;
  first_edge : Array[1..MAXN] of LongInt;
  edges : Array[1..2*MAXN] of LongInt;
  mafia : Array[1..MAXN] of Boolean;
  Watches : LongInt;

procedure ReadInput;
var
  Inp : Text;
  i : LongInt;
  a, b : LongInt;
  actptr : Array[1..MAXN] of LongInt;
  tree_edges : Array[1..MAXN-1, 1..2] of LongInt;
begin
  Assign(Inp, 'policie.in');
  Reset(Inp);
  ReadLn(Inp, n, p);
  for i := 1 to n do begin
    deg[i] := 0;
    actptr[i] := 0;
  end;
  {Nacteme hrany}
  for i := 1 to n-1 do begin
    ReadLn(Inp, tree_edges[i][1], tree_edges[i][2]);
    Inc(deg[tree_edges[i][1]]);
    Inc(deg[tree_edges[i][2]]);
  end;
  first_edge[1] := 1;
  for i := 2 to n do
    first_edge[i] := first_edge[i-1]+deg[i-1];
  {Priradime hrany k vrcholum}
  for i := 1 to n-1 do begin
    edges[first_edge[tree_edges[i][1]]+actptr[tree_edges[i][1]]] := tree_edges[i][2];
    Inc(actptr[tree_edges[i][1]]);
    edges[first_edge[tree_edges[i][2]]+actptr[tree_edges[i][2]]] := tree_edges[i][1];
    Inc(actptr[tree_edges[i][2]]);
  end;
  {Nacteme mafiany}
  for i := 1 to n do
    mafia[i] := False;
  for i := 1 to p do begin
    ReadLn(Inp, a);
    mafia[a] := True;
  end;
  Close(Inp);
end;

{Nalezneme vrchol v1 v seznamu sousedu v2}
function FindNeighbor(v1, v2 : LongInt) : LongInt;
var
  i : LongInt;
begin
  i := 0;
  while (i < deg[v2]) and (edges[first_edge[v2]+i] <> v1) do
    Inc(i);
  FindNeighbor := i;
end;

procedure RemoveVertex(what, from : LongInt; var QEnd : LongInt; var Q : LongArray; var NonLeaves : LongArray);
var
  pos : LongInt;
begin
  pos := FindNeighbor(what, from);
  edges[first_edge[from]+pos] := edges[first_edge[from]+deg[from]-1];
  Dec(deg[from]);
  if deg[what] > 1 then begin
    Dec(NonLeaves[from]);
    if NonLeaves[from] = 1 then begin
      Q[QEnd] := from;
      Inc(QEnd);
    end;
  end;
  {Pokud jsme vytvorili novy list, tak uz bude ve fronte, protoze mel <= 1 nonleaf souseda}
  {Staci tedy zjistit, jestli jsme nevytvorili vrchol s <= nonleaf sousedem}
  if deg[from] = 1 then begin
    what := edges[first_edge[from]];
    Dec(NonLeaves[what]);
    {Mame 1 nonleaf - zaradime do fronty na zpracovani}
    if NonLeaves[what] = 1 then begin
      Q[QEnd] := what;
      Inc(QEnd);
    end;
  end;
end;

function FindNonleaf(v : LongInt) : LongInt;
var
  i : LongInt;
begin
  for i := 0 to deg[v]-1 do
    if deg[edges[first_edge[v]+i]] > 1 then begin
      FindNonleaf := edges[first_edge[v]+i];
      Exit;
    end;
  FindNonleaf := 0;
end;

procedure ReduceGraph;
var
  NonLeaves : LongArray;
  Q : LongArray;
  QStart, QEnd : LongInt;
  i, v, neighbor : LongInt;
  offset : Integer;
begin
  for i := 1 to N do
    NonLeaves[i] := deg[i];
  {Vlozime do fronty vsechny listy}
  QStart := 1;
  QEnd := 1;
  for i := 1 to N do
    if deg[i] = 1 then begin
      if mafia[i] = False then begin
        Q[QEnd] := i;
        Inc(QEnd);
      end;
      Dec(NonLeaves[edges[first_edge[i]]]);
    end;
  {Vlozime do fronty vrcholy s <= 1 nelistovym sousedem}
  for i := 1 to N do
    if (deg[i] > 1) and (NonLeaves[i] <= 1) then begin
      Q[QEnd] := i;
      Inc(QEnd);
    end;
  {Odtrhavame vrcholy, dokud to jde}
  while QStart < QEnd do begin
    v := Q[QStart];
    Inc(QStart);
    {Odtrhavame list?}
    if deg[v] = 1 then begin
      if mafia[v] = true then
        continue;
      {Odmazeme list}
      neighbor := edges[first_edge[v]];
      RemoveVertex(v, neighbor, QEnd, Q, NonLeaves);
    end
    else if deg[v] = 2 then begin
      {Mafiansky vrchol s mafianskym listem?}
      if mafia[v] = true then begin
        {Potrebujeme hlidku}
        Inc(Watches);
        {Odebereme vrchol}
        neighbor := FindNonleaf(v);
        {Vsichni sousedi jsou listy?}
        if neighbor = 0 then
          Exit;
        RemoveVertex(v, neighbor, QEnd, Q, NonLeaves);
      end
      else begin
        {Nemafiansky vrchol stupne 2 s mafianskym listem}
        neighbor := FindNonleaf(v);
        {Oba sousede jsou listy?}
        if neighbor = 0 then begin
	  if mafia[edges[first_edge[v]]] and mafia[edges[first_edge[v]+1]] then begin
            {Listy musime oddelit}
            Inc(Watches);
          end;
          Exit;
        end;
        {Zbavime se vrcholu stupne 2}
        mafia[v] := True;
        deg[v] := 1;
        edges[first_edge[v]] := neighbor;
        Dec(NonLeaves[neighbor]);
	{Mame 1 nonleaf - zaradime do fronty na zpracovani}
	if NonLeaves[neighbor] = 1 then begin
	  Q[QEnd] := neighbor;
	  Inc(QEnd);
	end;
      end;
    end
    else if deg[v] > 2 then begin
      {Vsichni sousede az na jeden jsou mafianske listy. Potrebujeme hlidku}
      Inc(Watches);
      {Podstrom odebereme}
      neighbor := FindNonleaf(v);
      {Vsichni sousede jsou listy?}
      if neighbor = 0 then
        Exit;
      RemoveVertex(v, neighbor, QEnd, Q, NonLeaves);
    end;
  end;
end;

procedure WriteOutput;
var
  out : Text;
begin
  Assign(out, 'policie.out');
  Rewrite(out);
  WriteLn(out, Watches);
  Close(out);
end;

begin
  ReadInput;
  ReduceGraph;
  WriteOutput;
end.
